import "./cljs_env.js";
goog.provide('longdown.cli');
longdown.cli.cli_options = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, ["-d","--out-dir DIR","Output directory"], null),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, ["-h","--help"], null)], null);
longdown.cli.usage = (function longdown$cli$usage(options_summary){
return clojure.string.join.cljs$core$IFn$_invoke$arity$2("\n",new cljs.core.PersistentVector(null, 9, 5, cljs.core.PersistentVector.EMPTY_NODE, ["Convert longform markdown files to outline format used by Logseq","","Usage: longdown [options] file.md...","       longdown -","","When file is -, reads standard input and prints to standard output.","","Options:",options_summary], null));
});
longdown.cli.convert_files = (function longdown$cli$convert_files(out_dir,filenames){
var seq__21851 = cljs.core.seq(filenames);
var chunk__21852 = null;
var count__21853 = (0);
var i__21854 = (0);
while(true){
if((i__21854 < count__21853)){
var in_path = chunk__21852.cljs$core$IIndexed$_nth$arity$2(null,i__21854);
var out_path_21899 = shadow.esm.esm_import$node_path.join(out_dir,in_path);
shadow.esm.esm_import$node_fs.mkdirSync(shadow.esm.esm_import$node_path.dirname(out_path_21899),({"recursive": true}));

longdown.lib.spit(out_path_21899,longdown.lib.longform__GT_outline(longdown.lib.slurp(in_path)));


var G__21901 = seq__21851;
var G__21902 = chunk__21852;
var G__21903 = count__21853;
var G__21904 = (i__21854 + (1));
seq__21851 = G__21901;
chunk__21852 = G__21902;
count__21853 = G__21903;
i__21854 = G__21904;
continue;
} else {
var temp__5804__auto__ = cljs.core.seq(seq__21851);
if(temp__5804__auto__){
var seq__21851__$1 = temp__5804__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__21851__$1)){
var c__5568__auto__ = cljs.core.chunk_first(seq__21851__$1);
var G__21908 = cljs.core.chunk_rest(seq__21851__$1);
var G__21909 = c__5568__auto__;
var G__21910 = cljs.core.count(c__5568__auto__);
var G__21911 = (0);
seq__21851 = G__21908;
chunk__21852 = G__21909;
count__21853 = G__21910;
i__21854 = G__21911;
continue;
} else {
var in_path = cljs.core.first(seq__21851__$1);
var out_path_21913 = shadow.esm.esm_import$node_path.join(out_dir,in_path);
shadow.esm.esm_import$node_fs.mkdirSync(shadow.esm.esm_import$node_path.dirname(out_path_21913),({"recursive": true}));

longdown.lib.spit(out_path_21913,longdown.lib.longform__GT_outline(longdown.lib.slurp(in_path)));


var G__21914 = cljs.core.next(seq__21851__$1);
var G__21915 = null;
var G__21916 = (0);
var G__21917 = (0);
seq__21851 = G__21914;
chunk__21852 = G__21915;
count__21853 = G__21916;
i__21854 = G__21917;
continue;
}
} else {
return null;
}
}
break;
}
});
longdown.cli.convert_from_stdin = (function longdown$cli$convert_from_stdin(){
return cljs.core.println.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([clojure.string.trim_newline(longdown.lib.longform__GT_outline(longdown.lib.slurp(process.stdin.fd)))], 0));
});
longdown.cli._main = (function longdown$cli$_main(var_args){
var args__5775__auto__ = [];
var len__5769__auto___21922 = arguments.length;
var i__5770__auto___21923 = (0);
while(true){
if((i__5770__auto___21923 < len__5769__auto___21922)){
args__5775__auto__.push((arguments[i__5770__auto___21923]));

var G__21927 = (i__5770__auto___21923 + (1));
i__5770__auto___21923 = G__21927;
continue;
} else {
}
break;
}

var argseq__5776__auto__ = ((((0) < args__5775__auto__.length))?(new cljs.core.IndexedSeq(args__5775__auto__.slice((0)),(0),null)):null);
return longdown.cli._main.cljs$core$IFn$_invoke$arity$variadic(argseq__5776__auto__);
});

(longdown.cli._main.cljs$core$IFn$_invoke$arity$variadic = (function (args){
var map__21879 = clojure.tools.cli.parse_opts(args,longdown.cli.cli_options);
var map__21879__$1 = cljs.core.__destructure_map(map__21879);
var options = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21879__$1,new cljs.core.Keyword(null,"options","options",99638489));
var arguments$ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21879__$1,new cljs.core.Keyword(null,"arguments","arguments",-1182834456));
var summary = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21879__$1,new cljs.core.Keyword(null,"summary","summary",380847952));
var map__21880 = options;
var map__21880__$1 = cljs.core.__destructure_map(map__21880);
var out_dir = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__21880__$1,new cljs.core.Keyword(null,"out-dir","out-dir",-939021234));
if(cljs.core.truth_((function (){var or__5045__auto__ = new cljs.core.Keyword(null,"help","help",-439233446).cljs$core$IFn$_invoke$arity$1(options);
if(cljs.core.truth_(or__5045__auto__)){
return or__5045__auto__;
} else {
return cljs.core.empty_QMARK_(arguments$);
}
})())){
return cljs.core.println.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([longdown.cli.usage(summary)], 0));
} else {
if(((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.count(arguments$),(1))) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.first(arguments$),"-")))){
return longdown.cli.convert_from_stdin();
} else {
if((out_dir == null)){
cljs.core.println.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Output directory is required"], 0));

return process.exit((1));
} else {
return longdown.cli.convert_files(out_dir,arguments$);

}
}
}
}));

(longdown.cli._main.cljs$lang$maxFixedArity = (0));

/** @this {Function} */
(longdown.cli._main.cljs$lang$applyTo = (function (seq21871){
var self__5755__auto__ = this;
return self__5755__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq21871));
}));


//# sourceMappingURL=longdown.cli.js.map
